/* port address of internal registers */

#define IEGR1 (*(volatile unsigned char *)0xfff2)
#define IEGR2 (*(volatile unsigned char *)0xfff3)
#define IENR1 (*(volatile unsigned char *)0xfff4)
#define IENR1 (*(volatile unsigned char *)0xfff4)
#define IRR1 (*(volatile unsigned char *)0xfff6)
#define SMR0 (*(volatile unsigned char *)0xffa8)
#define BRR0 (*(volatile unsigned char *)0xffa9)
#define SCR0 (*(volatile unsigned char *)0xffaa)
#define TDR0 (*(volatile unsigned char *)0xffab)
#define SSR0 (*(volatile unsigned char *)0xffac)
#define RDR0 (*(volatile unsigned char *)0xffad)
#define FLMCR1 (*(volatile unsigned char *)0xff90)
#define FLMCR2 (*(volatile unsigned char *)0xff91)
#define FLPWCR (*(volatile unsigned char *)0xff92)
#define ERB1 (*(volatile unsigned char *)0xff93)
#define FENR (*(volatile unsigned char *)0xff9b)
#define TCRV0 (*(volatile unsigned char *)0xffa0)
#define TCSRV (*(volatile unsigned char *)0xffa1)
#define TCORA (*(volatile unsigned char *)0xffa2)
#define TCORB (*(volatile unsigned char *)0xffa3)
#define TCNTV (*(volatile unsigned char *)0xffa4)
#define TCRV1 (*(volatile unsigned char *)0xffa5)
#define TMRW (*(volatile unsigned char *)0xff80)
#define TCRW (*(volatile unsigned char *)0xff81)
#define TIERW (*(volatile unsigned char *)0xff82)
#define TSRW (*(volatile unsigned char *)0xff83)
#define TIOR0 (*(volatile unsigned char *)0xff84)
#define TIOR1 (*(volatile unsigned char *)0xff85)
#define TCNT (*(volatile unsigned short *)0xff86)
#define GRA (*(volatile unsigned short *)0xff88)
#define GRB (*(volatile unsigned short *)0xff8a)
#define GRC (*(volatile unsigned short *)0xff8c)
#define GRD (*(volatile unsigned short *)0xff8e)
#define TCSRWD (*(volatile unsigned char *)0xffc0)
#define TCWD (*(volatile unsigned char *)0xffc1)
#define TMWD (*(volatile unsigned char *)0xffc2)
#define PMR1 (*(volatile unsigned char *)0xffe0)
#define PCR1 (*(volatile unsigned char *)0xffe4)
#define PDR1 (*(volatile unsigned char *)0xffd4)
#define PUCR1 (*(volatile unsigned char *)0xffd0)
#define PCR2 (*(volatile unsigned char *)0xffe5)
#define PDR2 (*(volatile unsigned char *)0xffd5)
#define PMR5 (*(volatile unsigned char *)0xffe1)
#define PCR5 (*(volatile unsigned char *)0xffe8)
#define PDR5 (*(volatile unsigned char *)0xffd8)
#define PUCR5 (*(volatile unsigned char *)0xffd1)
#define PCR7 (*(volatile unsigned char *)0xffea)
#define PDR7 (*(volatile unsigned char *)0xffda)
#define PCR8 (*(volatile unsigned char *)0xffeb)
#define PDR8 (*(volatile unsigned char *)0xffdb)
#define PDRB (*(volatile unsigned char *)0xffdd)
#define TMA (*(volatile unsigned char *)0xffa6)
#define TCA (*(volatile unsigned char *)0xffa7)
#define ADDRA (*(volatile unsigned short *)0xffb0)
#define ADDRB (*(volatile unsigned short *)0xffb2)
#define ADDRC (*(volatile unsigned short *)0xffb4)
#define ADDRD (*(volatile unsigned short *)0xffb6)
#define ADCSR (*(volatile unsigned char *)0xffb8)
#define ADCR (*(volatile unsigned char *)0xffb9)
#define ICCR (*(volatile unsigned char *)0xffc4)

#define SYSCR1 (*(volatile unsigned char *)0xfff0)
#define SYSCR2 (*(volatile unsigned char *)0xfff1)
#define MSTCR1 (*(volatile unsigned char *)0xfff9)
