/* port address of internal registers */

#define SMR0	(*(volatile unsigned char *)0xffff81a0)
#define BRR0	(*(volatile unsigned char *)0xffff81a1)
#define SCR0	(*(volatile unsigned char *)0xffff81a2)
#define TDR0	(*(volatile unsigned char *)0xffff81a3)
#define SSR0	(*(volatile unsigned char *)0xffff81a4)
#define RDR0	(*(volatile unsigned char *)0xffff81a5)
#define SMR1	(*(volatile unsigned char *)0xffff81b0)
#define BRR1	(*(volatile unsigned char *)0xffff81b1)
#define SCR1	(*(volatile unsigned char *)0xffff81b2)
#define TDR1	(*(volatile unsigned char *)0xffff81b3)
#define SSR1	(*(volatile unsigned char *)0xffff81b4)
#define RDR1	(*(volatile unsigned char *)0xffff81b5)
#define SMR2	(*(volatile unsigned char *)0xffff81c0)
#define BRR2	(*(volatile unsigned char *)0xffff81c1)
#define SCR2	(*(volatile unsigned char *)0xffff81c2)
#define TDR2	(*(volatile unsigned char *)0xffff81c3)
#define SSR2	(*(volatile unsigned char *)0xffff81c4)
#define RDR2	(*(volatile unsigned char *)0xffff81c5)

#define TMDR	(*(volatile unsigned char *)0xffff8200)
#define TIERDH	(*(volatile unsigned char *)0xffff8202)
#define TSRDH	(*(volatile unsigned char *)0xffff8203)
#define TIERDL	(*(volatile unsigned char *)0xffff8204)
#define TSRDL	(*(volatile unsigned char *)0xffff8205)
#define TCR3	(*(volatile unsigned char *)0xffff8206)
#define TCR4	(*(volatile unsigned char *)0xffff8207)
#define TIOR3A	(*(volatile unsigned char *)0xffff8208)
#define TIOR3B	(*(volatile unsigned char *)0xffff8209)
#define TIOR4A	(*(volatile unsigned char *)0xffff820a)
#define TIOR4B	(*(volatile unsigned char *)0xffff820b)
#define TCR5	(*(volatile unsigned char *)0xffff820c)
#define TIOR5A	(*(volatile unsigned char *)0xffff820d)
#define TCNT3	(*(volatile unsigned short *)0xffff820e)
#define GR3A	(*(volatile unsigned short *)0xffff8210)
#define GR3B	(*(volatile unsigned short *)0xffff8212)
#define GR3C	(*(volatile unsigned short *)0xffff8214)
#define GR3D	(*(volatile unsigned short *)0xffff8216)
#define TCNT4	(*(volatile unsigned short *)0xffff8218)
#define GR4A	(*(volatile unsigned short *)0xffff821a)
#define GR4B	(*(volatile unsigned short *)0xffff821c)
#define GR4C	(*(volatile unsigned short *)0xffff821e)
#define GR4D	(*(volatile unsigned short *)0xffff8220)
#define TCNT5	(*(volatile unsigned short *)0xffff8222)
#define GR5A	(*(volatile unsigned short *)0xffff8224)
#define GR5B	(*(volatile unsigned short *)0xffff8226)

#define TIERE	(*(volatile unsigned char *)0xffff8240)
#define TSRE	(*(volatile unsigned char *)0xffff8241)
#define TCR7	(*(volatile unsigned char *)0xffff8242)
#define TCR6	(*(volatile unsigned char *)0xffff8243)
#define TCR9	(*(volatile unsigned char *)0xffff8244)
#define TCR8	(*(volatile unsigned char *)0xffff8245)
#define TCNT6	(*(volatile unsigned short *)0xffff8246)
#define CYLR6	(*(volatile unsigned short *)0xffff8248)
#define BFR6	(*(volatile unsigned short *)0xffff824a)
#define DTR6	(*(volatile unsigned short *)0xffff824c)
#define TCNT7	(*(volatile unsigned short *)0xffff824e)
#define CYLR7	(*(volatile unsigned short *)0xffff8250)
#define BFR7	(*(volatile unsigned short *)0xffff8252)
#define DTR7	(*(volatile unsigned short *)0xffff8254)
#define TCNT8	(*(volatile unsigned short *)0xffff8256)
#define CYLR8	(*(volatile unsigned short *)0xffff8258)
#define BFR8	(*(volatile unsigned short *)0xffff825a)
#define DTR8	(*(volatile unsigned short *)0xffff825c)
#define TCNT9	(*(volatile unsigned short *)0xffff825e)
#define CYLR9	(*(volatile unsigned short *)0xffff8260)
#define BFR9	(*(volatile unsigned short *)0xffff8262)
#define DTR9	(*(volatile unsigned short *)0xffff8264)

#define TCR1	(*(volatile unsigned char *)0xffff82c0)
#define TIOR1A	(*(volatile unsigned char *)0xffff82c1)
#define TIOR1B	(*(volatile unsigned char *)0xffff82c2)
#define TIOR1C	(*(volatile unsigned char *)0xffff82c3)
#define TIERB	(*(volatile unsigned char *)0xffff82c4)
#define TSRB	(*(volatile unsigned char *)0xffff82c5)
#define TCR2	(*(volatile unsigned char *)0xffff82c6)
#define TIOR2A	(*(volatile unsigned char *)0xffff82c7)
#define TIERC	(*(volatile unsigned char *)0xffff82c8)
#define TSRC	(*(volatile unsigned char *)0xffff82c9)
#define TCNT2	(*(volatile unsigned short *)0xffff82ca)
#define GR2A	(*(volatile unsigned short *)0xffff82cc)
#define GR2B	(*(volatile unsigned short *)0xffff82ce)
#define TCNT1	(*(volatile unsigned short *)0xffff82d0)
#define GR1A	(*(volatile unsigned short *)0xffff82d2)
#define GR1B	(*(volatile unsigned short *)0xffff82d4)
#define GR1C	(*(volatile unsigned short *)0xffff82d6)
#define GR1D	(*(volatile unsigned short *)0xffff82d8)
#define GR1E	(*(volatile unsigned short *)0xffff82da)
#define GR1F	(*(volatile unsigned short *)0xffff82dc)
#define OSBR	(*(volatile unsigned short *)0xffff82de)

#define TCR10	(*(volatile unsigned char *)0xffff82e0)
#define TCNR	(*(volatile unsigned char *)0xffff82e1)
#define TIERF	(*(volatile unsigned char *)0xffff82e2)
#define TSRF	(*(volatile unsigned char *)0xffff82e3)
#define DSTR	(*(volatile unsigned char *)0xffff82e5)
#define PSCR1	(*(volatile unsigned char *)0xffff82e9)
#define TSTR	(*(volatile unsigned short *)0xffff82ea)
#define DCNT10A	(*(volatile unsigned short *)0xffff82f0)
#define DCNT10B	(*(volatile unsigned short *)0xffff82f2)
#define DCNT10C	(*(volatile unsigned short *)0xffff82f4)
#define DCNT10D	(*(volatile unsigned short *)0xffff82f6)
#define DCNT10E	(*(volatile unsigned short *)0xffff82f8)
#define DCNT10F	(*(volatile unsigned short *)0xffff82fa)
#define DCNT10G	(*(volatile unsigned short *)0xffff82fc)
#define DCNT10H	(*(volatile unsigned short *)0xffff82fe)

#define IPRA	(*(volatile unsigned short *)0xffff8348)
#define IPRB	(*(volatile unsigned short *)0xffff834a)
#define IPRC	(*(volatile unsigned short *)0xffff834c)
#define IPRD	(*(volatile unsigned short *)0xffff834e)
#define IPRE	(*(volatile unsigned short *)0xffff8350)
#define IPRF	(*(volatile unsigned short *)0xffff8352)
#define IPRG	(*(volatile unsigned short *)0xffff8354)
#define IPRH	(*(volatile unsigned short *)0xffff8356)
#define ICR	(*(volatile unsigned short *)0xffff8358)
#define ISR	(*(volatile unsigned short *)0xffff835a)

#define PADR	(*(volatile unsigned short *)0xffff8380)
#define PAIOR	(*(volatile unsigned short *)0xffff8382)
#define PACR	(*(volatile unsigned short *)0xffff8384)
#define PBDR	(*(volatile unsigned short *)0xffff8386)
#define PBIOR	(*(volatile unsigned short *)0xffff8388)
#define PBCR	(*(volatile unsigned short *)0xffff838a)
#define PCDR	(*(volatile unsigned short *)0xffff8390)
#define PCIOR	(*(volatile unsigned short *)0xffff8392)
#define PCCR1	(*(volatile unsigned short *)0xffff8394)
#define PCCR2	(*(volatile unsigned short *)0xffff8396)
#define PDDR	(*(volatile unsigned short *)0xffff8398)
#define PDIOR	(*(volatile unsigned short *)0xffff839a)
#define PDCR	(*(volatile unsigned short *)0xffff839c)
#define CKCR	(*(volatile unsigned short *)0xffff839e)
#define PEDR	(*(volatile unsigned short *)0xffff83a0)
#define PEIOR	(*(volatile unsigned short *)0xffff83a2)
#define PECR	(*(volatile unsigned short *)0xffff83a4)
#define PFDR	(*(volatile unsigned short *)0xffff83a6)
#define PFIOR	(*(volatile unsigned short *)0xffff83a8)
#define PFCR1	(*(volatile unsigned short *)0xffff83aa)
#define PFCR2	(*(volatile unsigned short *)0xffff83ac)
#define PGDR	(*(volatile unsigned short *)0xffff83ae)
#define PGIOR	(*(volatile unsigned short *)0xffff83b0)
#define PGCR1	(*(volatile unsigned short *)0xffff83b2)
#define PGCR2	(*(volatile unsigned short *)0xffff83b4)
#define PHDR	(*(volatile unsigned short *)0xffff83b6)

#define ADTRGR	(*(volatile unsigned char *)0xffff83b8)

#define POPCR	(*(volatile unsigned short *)0xffff83c0)

#define SYSCR	(*(volatile unsigned char *)0xffff83c8)

#define CMSTR	(*(volatile unsigned short *)0xffff83d0)
#define CMCSR0	(*(volatile unsigned short *)0xffff83d2)
#define CMCNT0	(*(volatile unsigned short *)0xffff83d4)
#define CMCOR0	(*(volatile unsigned short *)0xffff83d6)
#define CMCSR1	(*(volatile unsigned short *)0xffff83d8)
#define CMCNT1	(*(volatile unsigned short *)0xffff83da)
#define CMCOR1	(*(volatile unsigned short *)0xffff83dc)

#define FLMCR1	(*(volatile unsigned char *)0xffff8580)
#define FLMCR2	(*(volatile unsigned char *)0xffff8581)
#define EBR1	(*(volatile unsigned char *)0xffff8582)
#define EBR2	(*(volatile unsigned char *)0xffff8583)

#define ADDR0H	(*(volatile unsigned char *)0xffff85d0)
#define ADDR0L	(*(volatile unsigned char *)0xffff85d1)
#define ADDR1H	(*(volatile unsigned char *)0xffff85d2)
#define ADDR1L	(*(volatile unsigned char *)0xffff85d3)
#define ADDR2H	(*(volatile unsigned char *)0xffff85d4)
#define ADDR2L	(*(volatile unsigned char *)0xffff85d5)
#define ADDR3H	(*(volatile unsigned char *)0xffff85d6)
#define ADDR3L	(*(volatile unsigned char *)0xffff85d7)
#define ADDR4H	(*(volatile unsigned char *)0xffff85d8)
#define ADDR4L	(*(volatile unsigned char *)0xffff85d9)
#define ADDR5H	(*(volatile unsigned char *)0xffff85da)
#define ADDR5L	(*(volatile unsigned char *)0xffff85db)
#define ADDR6H	(*(volatile unsigned char *)0xffff85dc)
#define ADDR6L	(*(volatile unsigned char *)0xffff85dd)
#define ADDR7H	(*(volatile unsigned char *)0xffff85de)
#define ADDR7L	(*(volatile unsigned char *)0xffff85df)
#define ADDR8H	(*(volatile unsigned char *)0xffff85e0)
#define ADDR8L	(*(volatile unsigned char *)0xffff85e1)
#define ADDR9H	(*(volatile unsigned char *)0xffff85e2)
#define ADDR9L	(*(volatile unsigned char *)0xffff85e3)
#define ADDR10H	(*(volatile unsigned char *)0xffff85e4)
#define ADDR10L	(*(volatile unsigned char *)0xffff85e5)
#define ADDR11H	(*(volatile unsigned char *)0xffff85e6)
#define ADDR11L	(*(volatile unsigned char *)0xffff85e7)
#define ADCSR0	(*(volatile unsigned char *)0xffff85e8)
#define ADCR0	(*(volatile unsigned char *)0xffff85e9)
#define ADDR12H	(*(volatile unsigned char *)0xffff85f0)
#define ADDR12L	(*(volatile unsigned char *)0xffff85f1)
#define ADDR13H	(*(volatile unsigned char *)0xffff85f2)
#define ADDR13L	(*(volatile unsigned char *)0xffff85f3)
#define ADDR14H	(*(volatile unsigned char *)0xffff85f4)
#define ADDR14L	(*(volatile unsigned char *)0xffff85f5)
#define ADDR15H	(*(volatile unsigned char *)0xffff85f6)
#define ADDR15L	(*(volatile unsigned char *)0xffff85f7)
#define ADCSR1	(*(volatile unsigned char *)0xffff85f8)
#define ADCR1	(*(volatile unsigned char *)0xffff85f9)

#define UBARH	(*(volatile unsigned short *)0xffff8600)
#define UBARL	(*(volatile unsigned short *)0xffff8602)
#define UBAMRH	(*(volatile unsigned short *)0xffff8604)
#define UBAMRL	(*(volatile unsigned short *)0xffff8606)
#define UBBR	(*(volatile unsigned short *)0xffff8608)

#define TCSR_WR	(*(volatile unsigned short *)0xffff8610)
#define TCSR_RD	(*(volatile unsigned char *)0xffff8610)
#define TCNT_WR	(*(volatile unsigned short *)0xffff8610)
#define TCNT_RD	(*(volatile unsigned char *)0xffff8611)
#define RSTSCR_WR (*(volatile unsigned char *)0xffff8612)
#define RSTSCR_RD (*(volatile unsigned char *)0xffff8613)
#define SBYCR	(*(volatile unsigned char *)0xffff8614)

#define BCR1	(*(volatile unsigned short *)0xffff8620)
#define BCR2	(*(volatile unsigned short *)0xffff8622)
#define WCR1	(*(volatile unsigned short *)0xffff8624)
#define WCR2	(*(volatile unsigned short *)0xffff8626)
#define RAMER	(*(volatile unsigned short *)0xffff8628)

#define DMAOR	(*(volatile unsigned short *)0xffff86b0)
#define SAR0	(*(volatile unsigned long *)0xffff86c0)
#define DAR0	(*(volatile unsigned long *)0xffff86c4)
#define DMATCR0	(*(volatile unsigned long *)0xffff86c8)
#define CHCR0	(*(volatile unsigned long *)0xffff86cc)
#define SAR1	(*(volatile unsigned long *)0xffff86d0)
#define DAR1	(*(volatile unsigned long *)0xffff86d4)
#define DMATCR1	(*(volatile unsigned long *)0xffff86d8)
#define CHCR1	(*(volatile unsigned long *)0xffff86dc)
#define SAR2	(*(volatile unsigned long *)0xffff86e0)
#define DAR2	(*(volatile unsigned long *)0xffff86e4)
#define DMATCR2	(*(volatile unsigned long *)0xffff86e8)
#define CHCR2	(*(volatile unsigned long *)0xffff86ec)
#define SAR3	(*(volatile unsigned long *)0xffff86f0)
#define DAR3	(*(volatile unsigned long *)0xffff86f4)
#define DMATCR3	(*(volatile unsigned long *)0xffff86f8)
#define CHCR3	(*(volatile unsigned long *)0xffff86fc)

