/* ѥåȥ */
#define	ETHER_MAX_PACKET	1514
/* ե졼ॿ */
#define IP_TYPE		0x800
#define ARP_TYPE	0x806
#define ARP_REQ		1
#define ARP_ANS		2
/* ץȥ륿 */
#define IP_ICMP		1
#define IP_UDP		17
#define IP_TCP		6
/* ICMP */
#define ICMP_ANS	0
#define ICMP_REQ	8

#define TCP_CLOSED	101
#define TCP_LISTEN	102
#define TCP_SYNRCVD	103
#define TCP_SYNSEND	104
#define TCP_ESTAB	105
#define TCP_FINWAIT1	106
#define TCP_FINWAIT2	107
#define TCP_CLOSING	108
#define TCP_TIMEWAIT	109
#define TCP_CLOSEWAIT	110
#define TCP_LASTACK	111

#define	EXP 0x20
#define	ACK 0x10
#define	PSH 0x08
#define	RST 0x04
#define	SYN 0x02
#define	FIN 0x01

#define MAX_SOCKET 32

struct	mac_info {
	unsigned int	ip;
	unsigned short	pri;
	char		mac[6];
};

typedef struct _ether_header {
	char dest[6];
	char src[6];
	unsigned short protocol;
} ether_header;

typedef struct _arp_header {
	char ether_header[14];
	unsigned short hard_type;
	unsigned short protocol_type;
	unsigned char hard_size;
	unsigned char protocol_size;
	unsigned short operation;
	char src_mac[6];
	char src_ip[4];
	char dest_mac[6];
	char dest_ip[4];
} arp_header;

typedef struct _ip_header {
	char ether_header[14];
	unsigned char version_size;
	unsigned char tos;
	unsigned short data_size;
	unsigned short number;
	unsigned short offset;
	unsigned char ttl;
	unsigned char protocol;
	unsigned short checksum;
	char src_ip[4];
	char dest_ip[4];
	char options[16];
} ip_header;

typedef struct _icmp_echo {
	unsigned char type;
	unsigned char code;
	unsigned short checksum;
	unsigned short number;
	unsigned short sequence;
	char data[256];
} icmp_echo;

typedef struct _udp_header {
	unsigned short src_port;
	unsigned short dest_port;
	unsigned short data_size;
	unsigned short checksum;
} udp_header;

struct sockaddr_in {
	unsigned char	sin_len;	/* ¤Τ礭 */
	unsigned char	sin_familly;	/* PF_INET */
	unsigned short	sin_port;	/* ݡֹ */
	unsigned int	sin_addr;	/* ɥ쥹   */
	unsigned int seq; /* ֹ */ // kishida koji for retry TCP packet
	unsigned int ack; /* ACKֹ */ // kishida koji for retry TCP packet
};

typedef struct _tcpinfo {
/* 2003/03/07 append start */
	struct sockaddr_in destaddr;
/* 2003/03/07 append end */
	unsigned int myseq;
	unsigned int rmseq;
	unsigned short time;
/* 2003/03/07 append start */
	unsigned short destport;
/* 2003/03/07 append end */
	unsigned char status;
	unsigned char index;
/* 2003/03/07 append start */
	unsigned char fActive;
/* 2003/03/07 append end */
	long timer_remain_msec ; /* */ //kishida koji for FIN timer
	unsigned char timer_counter ;	//kishida koji for FIN timer
} tcpinfo;

typedef struct _tcp_header {
	unsigned short	src_port;
	unsigned short	dest_port;
	unsigned int	src_seq;
	unsigned int	dest_seq;
	unsigned char	header_size;
	unsigned char	flag;
	unsigned short	winsize;
	unsigned short	checksum;
	unsigned short	dataptr;
	unsigned char	type;
	unsigned char	size;
	unsigned short	option;
	unsigned int	option2;
} tcp_header;

#define TCP_DATA	1
#define TCP_ACK		2
#define TCP_CLOSE	3
#define TCP_BEGIN	4
